public class GalRunner extends Thread {
	final double G=4.43e-3;
	double diskmass,diska,diskb,halomass,haloa,satmass, satmass0, rhosat, sata,satrad;
	double minrad = Double.POSITIVE_INFINITY;

	double[] wdot=new double[6];
	double[][] swdot = new double[Cannibal.nstars][6];

	//double rho2;
	double r0;


	public GalRunner() {
	}



	public void run() {

		double time, oldtime, dtime;
		setPriority(Thread.MIN_PRIORITY);
		diskmass=6e10;
		diska=6500;
		diskb=1300;

		haloa=10000;
		halomass=5.5e11;

		switch(Cannibal.satmassChoice.getSelectedIndex()) {
			case(0) : {
				satmass = diskmass * .1;
				break;
			}
			case(1) : {
				satmass = diskmass * .05;
				break;
			}
			case(2) : {
				satmass = diskmass * .01;
				break;
			}
		}
		satmass0 = satmass;
		sata=Cannibal.satradInput.getValue()*1000;
		satrad = 25*sata;

		time = 0;
		oldtime = Double.NEGATIVE_INFINITY;

		Cannibal.w = initSat(Cannibal.rperiInput.getValue()*1000, Cannibal.rapoInput.getValue()*1000, Cannibal.inclInput.getValue());


		populate(Cannibal.stars);

		double[] temp;


		dtime= Cannibal.timeStepSlider.getValue()/1000.;

		for(int i=0; i>-1; i++) {
			if((Cannibal.STOPFLAG==true)||(satmass/satmass0 < 0.02)) break;

			while(Cannibal.PAUSEFLAG == true) {
				try {
					Thread.sleep(50);
				} catch (InterruptedException e) {

				}
			}

			wdot = derivs(time,Cannibal.w);

			for(int j=0; j< Cannibal.nstars; j++) {
				swdot[j] = starderivs(time,Cannibal.stars[j]);
			}

			time=time+dtime;

			// If Running RK45 //
			if(Cannibal.nstars == 0) {
				temp = rk45(Cannibal.w, wdot, time,dtime);
				for(int j=0; j<6; j++) Cannibal.w[j] = temp[j];
				dtime = temp[6];
			} else {
				// If Running RK4 //
				dtime= Cannibal.timeStepSlider.getValue()/1000.;
				for(int j=0;j < Cannibal.nstars;j++) {
					starrk4(Cannibal.stars[j],swdot[j],6,time,dtime);
				}
				rk4(Cannibal.w,wdot,6,time,dtime);
			}

			for(int j=0; j< Cannibal.nstars; j++) {
				for(int k=0; k<3; k++) {
					Cannibal.starsC[j][k] = Cannibal.stars[j][k] - Cannibal.w[k];
				}
			}

			if(time - oldtime > FMath.rss(Cannibal.w[0], Cannibal.w[1], Cannibal.w[2])/750.) {
				Cannibal.graph.addPoints(time,Cannibal.w[0],Cannibal.w[1],Cannibal.w[2],satmass);
				oldtime = time;
			}
		}
		Cannibal.STOPFLAG=true;
		Cannibal.startButton.setEnabled(true);
		Cannibal.rapoInput.inputField.setEnabled(true);
		Cannibal.rperiInput.inputField.setEnabled(true);
		Cannibal.inclInput.inputField.setEnabled(true);
		Cannibal.satmassChoice.setEnabled(true);
		Cannibal.satradInput.inputField.setEnabled(true);
		Cannibal.nstarsChoice.setEnabled(true);
	}

	public double[] initSat(double rperi, double rapo, double inclin) {
		double[] returnArray = new double[6];
		if(inclin == 90) inclin -= 1e-6;
		else if(inclin == 0) inclin += 1e-6;
		inclin = inclin * Math.PI/180;
		returnArray[0] = rapo;
		returnArray[1] = 0;
		returnArray[2] = 0;
		double phiapo = -G*halomass/(rapo+haloa);
		phiapo = phiapo - G*diskmass/Math.sqrt(rapo*rapo+Math.pow((diska+diskb),2));
		double phiperi = -G*halomass/(rperi+haloa);
		phiperi = phiperi-G*diskmass/Math.sqrt(rperi*rperi+Math.pow((diska+diskb),2));

		double deltaphi = phiapo - phiperi;
		double vyapo2 = 2*deltaphi / (Math.pow((rapo/rperi),2)-1);
		double vyapo = Math.sqrt(vyapo2);

		returnArray[3] = 0;
		returnArray[4] = vyapo*Math.cos(inclin);
		returnArray[5] = vyapo*Math.sin(inclin);

		return(returnArray);
	}

	void populate(double[][] sw) {
		double xr, xv, p, q;
		double fq,pn;
		double e,emin, vemax;
		double msys = satmass0;
		double r0 = sata;
		double rsys = 5*sata;
		double ntot;
		double one = 1.0;
		double twopi = 2*Math.PI;
		double pi = Math.PI;
		double const1 = 1.20223157581242;
		double c1max = 0;
		double cth, sth, signs, phi, cthv, sthv, phiv;
		emin = -(G*msys)/r0;
		vemax = Math.sqrt(-2.*emin);

		for(int i=0; i<sw.length; i++) {
			do {
				xr = Math.random()*rsys;
				xv = Math.random()*vemax;
				e=0.5*xv*xv-(G*msys)/(xr+r0);
			} while((e>0)||(e<emin));

			q = Math.sqrt(-r0*e/(G*msys));
			p = Math.random();
			fq = (3.*Math.asin(q)+q*Math.sqrt(1.-q*q)*(1.-2.*q*q)*(8.*Math.pow(q,4)-8.*q*q-3.))/Math.pow(1.-Math.pow(q,2),2.5);
			pn = (xr*xr/(r0*r0))*(xv*xv/((G*msys)/r0))*fq/const1;
			if(p <= pn) {
				cth = 2.*(Math.random() - .5);
				sth = Math.sqrt(1.-cth*cth);
				signs = 2.*(Math.random() - .5);
				sth = signs*sth/Math.abs(signs);
				phi = twopi*Math.random();
				cthv = 2.*(Math.random()-.5);
				sthv = Math.sqrt(1.0-cthv*cthv);
				signs = 2.0*(Math.random()-.5);
				sthv = signs*sthv/Math.abs(signs);
				phiv = twopi * Math.random();
				sw[i][0] = xr*sth*Math.cos(phi);
				sw[i][1] = xr*sth*Math.sin(phi);
				sw[i][2] = xr*cth;
				sw[i][3] = xv*sthv*Math.cos(phiv);
				sw[i][4] = xv*sthv*Math.sin(phiv);
				sw[i][5] = xv*cthv;
			} else i--;
		}

		for(int i=0; i<sw.length; i++) {
			for(int j=0; j<6; j++) {
				sw[i][j]=sw[i][j]+Cannibal.w[j];
			}
	    }
	}




	public double[] derivs(double time,double[] sat) {
		double[] wdot = new double[6];
		double loggamma;
		double sphr, cylr;

		double rc2, sfac, gphixh, gphiyh, gphizh, vch;

		double sz2b2=0,zterm,dfac,gphixd,gphiyd,gphizd,vcd2,vcd,vc,sigv;

		double rhoh, rhod, fac1, fac2, rho=0,v,x,dvdt;

		wdot[0]=sat[3];
		wdot[1]=sat[4];
		wdot[2]=sat[5];

		sphr= Math.sqrt(Math.pow(sat[0],2.) + Math.pow(sat[1],2.)+ Math.pow(sat[2],2.));
        cylr=Math.sqrt(Math.pow(sat[0],2.)+Math.pow(sat[1],2.));


		// Compute the disk density up here so we dont have to do it more than once
		sz2b2 = Math.sqrt(Math.pow(sat[2],2) + Math.pow(diskb,2));
		rhoh=(halomass/2.0/Math.PI)*(haloa/sphr)/Math.pow((sphr+haloa),3);
		if(Cannibal.diskToggle.getState()==true) {
			rhod=(Math.pow(diskb,2.))*(diskmass/4./3.1416);
			rhod=rhod* diska*Math.pow(cylr,2)+(diska+3*sz2b2)*Math.pow((diska+sz2b2),2);
			fac1=Math.pow((sz2b2*sz2b2),(1.5));
			fac2= Math.pow((Math.pow(cylr,2) + Math.pow((diska+sz2b2),2)),2.5);
			rhod=rhod/fac1;
			rhod=rhod/fac2;
		} else {
			rhod = 0;
		}
		rho=rhoh+rhod;



		// tidal stripping
		minrad = Math.min(minrad,sphr);
		if(Cannibal.mlToggle.getState()==true) {
			//if(sphr == minrad) { // Faulty logic
				double scanmin=0,r,i=1;
				rhosat = (satmass0/(2*Math.PI)) * (sata/satrad) * (1/Math.pow((satrad+sata),3));
				if(rhosat <= rho) {
					while(true) {
						r= scanmin + (satrad/(2*i));
						rhosat = (satmass0/(2*Math.PI)) * (sata/r) * (1/Math.pow((r+sata),3));
						if(Math.abs((rhosat - rho)/rho) < 0.001) {
							satmass = satmass0 * ( Math.pow(r,2)/Math.pow((r+sata),2) );
							break;
						}
						else if(rhosat > rho) {
							scanmin = r;
						}
						i=i*2;
					}
					satrad=r;
				}
			//}
		}


		// halo potential
		rc2 = 1./Math.pow((sphr+haloa),2);
		sfac = G*halomass*rc2/sphr;
		gphixh = -sfac * sat[0];
		gphiyh = -sfac * sat[1];
		gphizh = -sfac * sat[2];
		vch = Math.sqrt(G*halomass*sphr)/(sphr+haloa);

		// disk potential
		if(Cannibal.diskToggle.getState()==true) {
			zterm = 1.0 / Math.sqrt( Math.pow((cylr*cylr + Math.pow((diska + sz2b2),2)),3));
			dfac = G*diskmass*zterm;
			vcd2=2*G*diskmass*cylr*cylr/Math.pow((cylr*cylr + Math.pow((diska+diskb),2) ),1.5);
			vcd=Math.sqrt(vcd2);
			vc=Math.sqrt(Math.pow(vcd,2)+Math.pow(vch,2));
			sigv=vc/Math.sqrt(2.);
			gphixd = -dfac*sat[0];
			gphiyd = -dfac*sat[1];
			gphizd = -dfac*sat[2] * (diska + sz2b2) / sz2b2;
		} else {
			vc=vch;
			gphixd = 0;
			gphiyd = 0;
			gphizd = 0;
		}

		// dynfric
		if(Cannibal.dfToggle.getState()==true) {
			loggamma=3.;
			rho=rhoh+rhod;
			v=Math.sqrt(Math.pow(sat[3],2)+Math.pow(sat[4],2)+Math.pow(sat[5],2));
			x=v/(Math.sqrt(2.)*vc);
			dvdt=-4*3.1416*loggamma*G*G*satmass*rho/v/v/v * (erf(x)-(2.*x/Math.sqrt(3.1416))*Math.exp(-x*x));
		} else {
			dvdt = 0;
		}

		wdot[3]=gphixh+gphixd+dvdt*sat[3];
		wdot[4]=gphiyh+gphiyd+dvdt*sat[4];
		wdot[5]=gphizh+gphizd+dvdt*sat[5];

		//rho2 = rho;

		return(wdot);
	}


	public double[] starderivs(double time,double[] star) {
		double[] wdot = new double[6];
		double loggamma;
		double sphr, cylr;

		double rc2, sfac, gphixh, gphiyh, gphizh, vch;

		double sz2b2=0,zterm,dfac,gphixd,gphiyd,gphizd;

		double dx,dy,dz,satforce,gphixs,gphiys,gphizs;


		wdot[0]=star[3];
		wdot[1]=star[4];
		wdot[2]=star[5];

		sphr= Math.sqrt(Math.pow(star[0],2.) + Math.pow(star[1],2.)+ Math.pow(star[2],2.));

		// halo potential
		rc2 = 1./Math.pow((sphr+haloa),2);
		sfac = G*halomass*rc2/sphr;
		gphixh = -sfac * star[0];
		gphiyh = -sfac * star[1];
		gphizh = -sfac * star[2];
		vch = Math.sqrt(G*halomass*sphr)/(sphr+haloa);

		// disk potential

		if(Cannibal.diskToggle.getState()==true) {
			cylr=Math.sqrt(Math.pow(star[0],2.)+Math.pow(star[1],2.));
		    sz2b2 = Math.sqrt(Math.pow(star[2],2) + Math.pow(diskb,2));
		    zterm = 1.0 / Math.sqrt( Math.pow((cylr*cylr + Math.pow((diska + sz2b2),2)),3));
		    dfac = G*diskmass*zterm;
			gphixd = -dfac*star[0];
			gphiyd = -dfac*star[1];
			gphizd = -dfac*star[2] * (diska + sz2b2) / sz2b2;
		} else {
			gphixd = 0;
			gphiyd = 0;
			gphizd = 0;
		}

		// sat potential
		dx=star[0]-Cannibal.w[0];
		dy=star[1]-Cannibal.w[1];
		dz=star[2]-Cannibal.w[2];

		sphr=Math.sqrt(dx*dx+dy*dy+dz*dz);
		if (sphr>satrad) {
			satforce=-G*satmass/sphr/sphr;
		} else {
			satforce=-G*satmass0/(sphr+sata)/(sphr+sata);
		}
		double eps=0.;
		gphixs=dx*satforce/(sphr+eps);
		gphiys=dy*satforce/(sphr+eps);
		gphizs=dz*satforce/(sphr+eps);

		wdot[3]=gphixh+gphixd+gphixs;
		wdot[4]=gphiyh+gphiyd+gphiys;
		wdot[5]=gphizh+gphizd+gphizs;

		return(wdot);
	}


	void rk4(double[] y, double[] dydx, int n, double x, double h) {
		final int NMAX=10;
		double[] yt=new double[NMAX], dyt = new double[NMAX], dym=new double[NMAX], yout=new double[n];
		double hh, h6, xh;
		hh=h*0.5;
		h6=h/6.;
		xh=x+hh;

		for(int i=0; i<n; i++) {
			yt[i] = y[i] + hh*dydx[i];
		}
		dyt = derivs(xh,yt);

		for(int i=0; i<n; i++) {
			yt[i] = y[i] + hh*dyt[i];
		}
		dym = derivs(xh,yt);

		for(int i=0; i<n; i++) {
			yt[i] = y[i] + h*dym[i];
			dym[i] = dyt[i] + dym[i];
		}
		dyt = derivs(x+h,yt);

		for(int i=0; i<n; i++) {
			y[i] = y[i] + h6 * (dydx[i] + dyt[i] + 2.*dym[i]);
		}
	}


    /** Returns an array 1 element larger than pos, where the element at size-1 is the new timestep. **/

    double[] rk45(double[] pos, double[] dydx, double t, double h) {
		double err;
		int n = pos.length, count=0;
		double[] k1= new double[n], k2=new double[n], k3= new double[n], k4 = new double[n], k5= new double[n], k6= new double[n];
		double[] yt= new double[n], y4= new double[n], y5 = new double[n];
		double[] dot;
		double c21 = 0.25,c31 = 0.09375,c32 = 0.28125,c41 = 0.87938097405553,
			c42 = -3.2771961766045  ,c43 = 3.3208921256258,c51 = 2.0324074074074,c52 = -8.0,
			c53 = 7.1734892787524   ,c54 = -0.20589668615984,c61 = -0.2962962962963,c62 = 2.0,
			c63 = -1.3816764132554  ,c64 = 0.45297270955166,c65 = -0.275,a1  = 0.11574074074074,
			a3  = 0.54892787524366  ,a4  = 0.5353313840156,a5  = -0.2,b1  = 0.11851851851852,
			b3  = 0.51898635477583  ,b4  = 0.50613149034201,b5  = -0.18,b6  = 0.036363636363636,
			c40 = 0.92307692307692;

		h=h*2;

		while (true) {

			err=0;

			for(int i=0; i< n; i++) {
				k1[i] = h*dydx[i];
			}

			for(int i=0; i< n; i++) {
				yt[i] = pos[i] + c21*k1[i];
			}
			dot = derivs(t+ 0.25*h,yt);
			for(int i=0; i<n; i++) {
				k2[i] = h*dot[i];
			}

			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c31*k1[i] + c32*k2[i];
			}
			dot = derivs(t+0.375*h,yt);
			for(int i=0; i< n; i++) {
				k3[i] = h*dot[i];
			}

			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c41*k1[i] + c42*k2[i] + c43*k3[i];
			}
			dot = derivs(t+c40*h,yt);
			for(int i=0; i< n; i++) {
				k4[i] = h*dot[i];
			}

			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c51*k1[i] + c52*k2[i] + c53*k3[i] + c54*k4[i];
			}
			dot = derivs(t+h,yt);
			for(int i=0; i< n; i++) {
				k5[i] = h*dot[i];
			}

			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c61*k1[i] + c62*k2[i] + c63*k3[i] + c64*k4[i] + c65*k5[i];
			}
			dot = derivs(t+0.5*h,yt);
			for(int i=0; i<n; i++) {
				k6[i] = h * dot[i];
			}

			for(int i=0; i< n; i++) {
				y5[i] = pos[i] + b1*k1[i] + b3*k3[i] + b4*k4[i] + b5*k5[i] + b6*k6[i];
				y4[i] = pos[i] + a1*k1[i] + a3*k3[i] + a4*k4[i] + a5*k5[i];
				err = Math.max(Math.abs( (y4[i] - y5[i])/y5[i]), err);
			}

			if(err > 1e-4) {
				h = h/2.0;
				//System.out.println(err);
			} else {
				break;
			}
		}

		double[] result = new double[n+1];
		for(int i=0; i< n; i++) {
			result[i] = y5[i];
		}

		result[n] = h;

		return(result);
    }



    /** Returns an array 1 element larger than pos, where the element at size-1 is the new timestep. **/

    double[] stark45(double[] pos, double[] dydx, double t, double h) {
		double err;
		int n = pos.length, count=0;
		double[] k1= new double[n], k2=new double[n], k3= new double[n], k4 = new double[n], k5= new double[n], k6= new double[n];
		double[] yt= new double[n], y4= new double[n], y5 = new double[n];
		double[] dot;
		double c21 = 0.25,c31 = 0.09375,c32 = 0.28125,c41 = 0.87938097405553,
			c42 = -3.2771961766045  ,c43 = 3.3208921256258,c51 = 2.0324074074074,c52 = -8.0,
			c53 = 7.1734892787524   ,c54 = -0.20589668615984,c61 = -0.2962962962963,c62 = 2.0,
			c63 = -1.3816764132554  ,c64 = 0.45297270955166,c65 = -0.275,a1  = 0.11574074074074,
			a3  = 0.54892787524366  ,a4  = 0.5353313840156,a5  = -0.2,b1  = 0.11851851851852,
			b3  = 0.51898635477583  ,b4  = 0.50613149034201,b5  = -0.18,b6  = 0.036363636363636,
			c40 = 0.92307692307692;

		h=h*2;

		while (true) {

			err=0;

			for(int i=0; i< n; i++) {
				k1[i] = h*dydx[i];
			}
			for(int i=0; i< n; i++) {
				yt[i] = pos[i] + c21*k1[i];
			}
			dot = starderivs(t+ 0.25*h,yt);
			for(int i=0; i<n; i++) {
				k2[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c31*k1[i] + c32*k2[i];
			}
			dot = starderivs(t+0.375*h,yt);
			for(int i=0; i< n; i++) {
				k3[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c41*k1[i] + c42*k2[i] + c43*k3[i];
			}
			dot = starderivs(t+c40*h,yt);
			for(int i=0; i< n; i++) {
				k4[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c51*k1[i] + c52*k2[i] + c53*k3[i] + c54*k4[i];
			}
			dot = starderivs(t+h,yt);
			for(int i=0; i< n; i++) {
				k5[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
				yt[i]  = pos[i] + c61*k1[i] + c62*k2[i] + c63*k3[i] + c64*k4[i] + c65*k5[i];
			}
			dot = starderivs(t+0.5*h,yt);
			for(int i=0; i<n; i++) {
				k6[i] = h * dot[i];
			}


			for(int i=0; i< n; i++) {
				y5[i] = pos[i] + b1*k1[i] + b3*k3[i] + b4*k4[i] + b5*k5[i] + b6*k6[i];
				y4[i] = pos[i] + a1*k1[i] + a3*k3[i] + a4*k4[i] + a5*k5[i];
				err = Math.max(Math.abs( (y4[i] - y5[i])/y5[i]), err);
			}
			//System.out.println(h+" "+err);
			if(err > 1e-4) {
				h = h/2.0;
			} else {
				break;
			}
		} //while ((err > 1e-4)&&(count < 10));

		double[] result = new double[n+1];
		for(int i=0; i< n; i++) {
			result[i] = y5[i];
		}

		System.out.println(h);
		result[n] = h;

		return(result);
    }



	void starrk4(double[] y, double[] dydx, int n, double x, double h) {
		final int NMAX=10;
		double[] yt=new double[NMAX], dyt = new double[NMAX], dym=new double[NMAX], yout=new double[n];
		double hh, h6, xh;
		hh=h*0.5;
		h6=h/6.;
		xh=x+hh;

		for(int i=0; i<n; i++) {
			yt[i] = y[i] + hh*dydx[i];
		}


		dyt = starderivs(xh,yt);


		for(int i=0; i<n; i++) {
			yt[i] = y[i] + hh*dyt[i];
		}

		dym = starderivs(xh,yt);


		for(int i=0; i<n; i++) {
			yt[i] = y[i] + h*dym[i];
			dym[i] = dyt[i] + dym[i];
		}


		dyt = starderivs(x+h,yt);


		for(int i=0; i<n; i++) {
			y[i] = y[i] + h6 * (dydx[i] + dyt[i] + 2.*dym[i]);
		}
		//return(yout);
	}

	double erf(double x) {
		double erf;
		erf = 1-erfcc(x);
		return(erf);
	}

	double erfcc(double x) {
		double z,t, erfcc;
		z = Math.abs(x);
		t = 1./(1.+0.5*z);
		erfcc=t*Math.exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+t*(.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+t*(1.48851587+t*(-.82215223+t*.17087277)))))))));
		return(erfcc);
	}

}

