import java.awt.*;
import java.awt.Component.*;
import java.awt.event.*;


public class InputSlider extends Scrollbar {

	double min, max;

	int increment;

	Label label, valueLabel;

	public InputSlider(String labeltext, int value, double min, double max, int inc) {
		super(HORIZONTAL,(int)(value),0,(int)0,(int)(max+.01));
		setUnitIncrement(inc);
		this.increment = inc;
		this.label = new Label(labeltext);
		this.valueLabel = new Label(value+"");
		setupListeners();
	}

	public void setupListeners() {
		addAdjustmentListener(new AdjustmentListener() {
			public void adjustmentValueChanged(AdjustmentEvent e) {
				valueLabel.setText(Double.toString(getValue()));
			}
		});
		addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				if(e.isShiftDown()==true) {
					setUnitIncrement(10);
					setBlockIncrement(100);
				} else {
					setUnitIncrement(increment);
					setBlockIncrement(increment*10);
				}
			}
		});
	}

}