import java.lang.Math;

public class lmc {
	double G,diskmass,diska,diskb,halomass,haloa,satmass;
        double r2;

	public static void main(String[] args) {
		lmc mylmc = new lmc();
	}



	public lmc() {
		double[] w = new double[6], w2, wdot=new double[6];
		double time, dtime;

		G=4.43e-3;
		diskmass=6e10;
		diska=6500;
		diskb=1300;
		haloa=10000;
		halomass=5.5e11;
		satmass=6e9;
		w[0]=42000;
		w[1]=0;
		w[2]=-27000;
		w[3]=0;
		w[4]=213;
		w[5]=-48;
		w2=(double[])w.clone();
		dtime=5;
		time=0;

		long startTime, endTime, startTime2, endTime2;

		startTime = System.currentTimeMillis();

		r2=w[0]*w[0]+w[1]*w[1]+w[2]*w[2];
	  	while (r2 > 1e6) {
		    wdot = derivs(time,w);
		    time=time+dtime;
		    w = rk4(w,wdot,6,time,dtime);
		    r2=w[0]*w[0]+w[1]*w[1]+w[2]*w[2];
		    //System.out.println(time+" "+dtime+" "+w[0]+" "+w[1]+" "+w[2]);
		}
		endTime = System.currentTimeMillis();
		time=0;
		r2=w2[0]*w2[0]+w2[1]*w2[1]+w2[2]*w2[2];
		for (int i=0; i<6; i++ ) w[i]=w2[i];
		startTime2 = System.currentTimeMillis();
		while (r2 > 1e6) {
		    time=time+dtime;
		    w2 = rk45(w,time,dtime);
		    for (int i=0; i<6; i++ ) w[i]=w2[i];
		    dtime = w2[w2.length-1];
		    r2=w2[0]*w2[0]+w2[1]*w2[1]+w2[2]*w2[2];
		    //System.out.println(time+" "+dtime+" "+w2[0]+" "+w2[1]+" "+w2[2]);
		}
		endTime2 = System.currentTimeMillis();
		System.out.println("RK4: " + (endTime-startTime) + "    RK45: " + (endTime2-startTime2));
	}


    public double[] derivs(double time,double[] w) {
	double[] wdot = new double[6];
	double loggamma;
	double sphr, cylr;

	double rc2, sfac, gphixh, gphiyh, gphizh, vch;

	double sz2b2,zterm,dfac,gphixd,gphiyd,gphizd,vcd2,vcd,vc,sigv;

	double rhoh, rhod, fac1, fac2, rho,v,x,dvdt;

	wdot[0]=w[3];
	wdot[1]=w[4];
	wdot[2]=w[5];

	sphr= Math.sqrt(Math.pow(w[0],2.) + Math.pow(w[1],2.)+ Math.pow(w[2],2.));
	cylr=Math.sqrt(Math.pow(w[0],2.)+Math.pow(w[1],2.));

	// halo potential
	rc2 = 1./Math.pow((sphr+haloa),2);
	sfac = G*halomass*rc2/sphr;
	gphixh = -sfac * w[0];
	gphiyh = -sfac * w[1];
	gphizh = -sfac * w[2];
	vch = Math.sqrt(G*halomass*sphr)/(sphr+haloa);

	// disk potential
	sz2b2 = Math.sqrt(Math.pow(w[2],2) + Math.pow(diskb,2));
	zterm = 1.0 / Math.sqrt( Math.pow((cylr*cylr + Math.pow((diska + sz2b2),2)),3));
	dfac = G*diskmass*zterm;
	gphixd = -dfac*w[0];
	gphiyd = -dfac*w[1];
	gphizd = -dfac*w[2] * (diska + sz2b2) / sz2b2;
	vcd2=2*G*diskmass*cylr*cylr/Math.pow((cylr*cylr + Math.pow((diska+diskb),2) ),1.5);
	vcd=Math.sqrt(vcd2);
	vc=Math.sqrt(Math.pow(vcd,2)+Math.pow(vch,2));
	sigv=vc/Math.sqrt(2.);

	// dynfric
	loggamma=3.;
	rhoh=(halomass/2.0/3.1416)*(haloa/sphr)/Math.pow((sphr+haloa),3);
	rhod=(Math.pow(diskb,2.))*(diskmass/4./3.1416);
	rhod=rhod* diska*Math.pow(cylr,2)+(diska+3*sz2b2)*Math.pow((diska+sz2b2),2);
	fac1=Math.pow((sz2b2*sz2b2),(1.5));
	fac2= Math.pow((Math.pow(cylr,2) + Math.pow((diska+sz2b2),2)),2.5);
	rhod=rhod/fac1;
	rhod=rhod/fac2;
	rho=rhoh+rhod;
	v=Math.sqrt(Math.pow(w[3],2)+Math.pow(w[4],2)+Math.pow(w[5],2));
	x=v/(Math.sqrt(2.)*vc);
	dvdt=-4*3.1416*loggamma*G*G*satmass*rho/v/v/v * (erf(x)-(2.*x/Math.sqrt(3.1416))*Math.exp(-x*x));

	wdot[3]=gphixh+gphixd+dvdt*w[3];
	wdot[4]=gphiyh+gphiyd+dvdt*w[4];
	wdot[5]=gphizh+gphizd+dvdt*w[5];

	return(wdot);
    }



    double[] rk4(double[] y, double[] dydx, int n, double x, double h) {
	final int NMAX=10;
	double[] yt=new double[NMAX], dyt = new double[NMAX], dym=new double[NMAX], yout=new double[n];
	double hh, h6, xh;
	hh=h*0.5;
	h6=h/6.;
	xh=x+hh;

	for(int i=0; i<n; i++) {
	    yt[i] = y[i] + hh*dydx[i];
	}
	dyt = derivs(xh,yt);

	for(int i=0; i<n; i++) {
	    yt[i] = y[i] + hh*dyt[i];
	}
	dym = derivs(xh,yt);

	for(int i=0; i<n; i++) {
	    yt[i] = y[i] + h*dym[i];
	    dym[i] = dyt[i] + dym[i];
	}
	dyt = derivs(x+h,yt);

	for(int i=0; i<n; i++) {
	    yout[i] = y[i] + h6 * (dydx[i] + dyt[i] + 2.*dym[i]);
	}

	return(yout);
    }


    /** Returns an array 1 element larger than pos, where the element at size-1 is the new timestep. **/

    double[] rk45(double[] pos, double t, double h) {
		double err=0;
		int n = pos.length, count=0;
		double[] k1= new double[n], k2=new double[n], k3= new double[n], k4 = new double[n], k5= new double[n], k6= new double[n];
		double[] yt= new double[n], y4= new double[n], y5 = new double[n];
		double[] dot;
		double c21 = 0.25,c31 = 0.09375,c32 = 0.28125,c41 = 0.87938097405553,
			c42 = -3.2771961766045  ,c43 = 3.3208921256258,c51 = 2.0324074074074,c52 = -8.0,
			c53 = 7.1734892787524   ,c54 = -0.20589668615984,c61 = -0.2962962962963,c62 = 2.0,
			c63 = -1.3816764132554  ,c64 = 0.45297270955166,c65 = -0.275,a1  = 0.11574074074074,
			a3  = 0.54892787524366  ,a4  = 0.5353313840156,a5  = -0.2,b1  = 0.11851851851852,
			b3  = 0.51898635477583  ,b4  = 0.50613149034201,b5  = -0.18,b6  = 0.036363636363636,
			c40 = 0.92307692307692;

		h=h*2;

		while (true) {

			err=0;

			dot = derivs(t,pos);
			for(int i=0; i< n; i++) {
			k1[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
			yt[i] = pos[i] + c21*k1[i];
			}
			dot = derivs(t+ 0.25*h,yt);
			for(int i=0; i<n; i++) {
			k2[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
			yt[i]  = pos[i] + c31*k1[i] + c32*k2[i];
			}
			dot = derivs(t+0.375*h,yt);
			for(int i=0; i< n; i++) {
			k3[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
			yt[i]  = pos[i] + c41*k1[i] + c42*k2[i] + c43*k3[i];
			}
			dot = derivs(t+c40*h,yt);
			for(int i=0; i< n; i++) {
			k4[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
			yt[i]  = pos[i] + c51*k1[i] + c52*k2[i] + c53*k3[i] + c54*k4[i];
			}
			dot = derivs(t+h,yt);
			for(int i=0; i< n; i++) {
			k5[i] = h*dot[i];
			}


			for(int i=0; i< n; i++) {
			yt[i]  = pos[i] + c61*k1[i] + c62*k2[i] + c63*k3[i] + c64*k4[i] + c65*k5[i];
			}
			dot = derivs(t+0.5*h,yt);
			for(int i=0; i<n; i++) {
			k6[i] = h * dot[i];
			}


			for(int i=0; i< n; i++) {
			y5[i] = pos[i] + b1*k1[i] + b3*k3[i] + b4*k4[i] + b5*k5[i] + b6*k6[i];
			y4[i] = pos[i] + a1*k1[i] + a3*k3[i] + a4*k4[i] + a5*k5[i];
			err = Math.max(Math.abs( (y4[i] - y5[i])/y5[i]), err);


			}
			//System.out.println(h+" "+err);
			if(err > 1e-4) {
			h = h/2.0;
			} else {
			break;
			}

			count++;
		} //while ((err > 1e-4)&&(count < 10));

		double[] result = new double[n+1];
		for(int i=0; i< n; i++) {
			result[i] = y5[i];
		}

		result[n] = h;

		return(result);
    }



	double erf(double x) {
		double erf;
		erf = 1-erfcc(x);
		return(erf);
	}

	double erfcc(double x) {
		double z,t, erfcc;
		z = Math.abs(x);
		t = 1./(1.+0.5*z);
		erfcc=t*Math.exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+t*(.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+t*(1.48851587+t*(-.82215223+t*.17087277)))))))));
		return(erfcc);
	}
}

